import { Message, Signature } from "@canvas-js/interfaces";
export type SignatureTuple = [codec: string, publicKey: string, signature: Uint8Array];
export type MessageTuple = [
    signature: SignatureTuple,
    topic: string,
    clock: number,
    parents: Uint8Array[],
    payload: unknown
];
export declare function decodeSignedMessage(value: Uint8Array): [id: string, signature: Signature, message: Message];
export declare function encodeSignedMessage({ codec, publicKey, signature }: Signature, { topic, clock, parents, payload }: Message): [key: Uint8Array, value: Uint8Array];
export declare function getNextClock(parents: Uint8Array[]): number;
export declare const KEY_LENGTH = 20;
export declare const ID_LENGTH = 32;
export declare const MIN_MESSAGE_ID = "00000000000000000000000000000000";
export declare const MAX_MESSAGE_ID = "vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv";
export declare const messageIdPattern: RegExp;
export declare function getKey(clock: number, value: Uint8Array): Uint8Array;
export declare const encodeId: (id: string) => Uint8Array;
export declare const decodeId: (key: Uint8Array) => string;
